camera = {}
camera.x = 0
camera.y = 0
camera.scaleX = 1
camera.scaleY = 1
camera.rotation = 0

function love.load()

	char = love.graphics.newImage("char.png")

	movement = {}
	movement.x = 100
	movement.y = 100
	movement.yvel = 0
	movement.xvel = 0
	movement.friction = 9.5
	movement.speed = 4500

	rotcalc = {}
	rotcalc.x = nil
	rotcalc.y = nil
	rotcalc.allowed = 0

	rotcalc.angle = nil

	background = love.graphics.newImage("BG.png")

	pointercalc = {}

end

function love.update(dt)

	print("Screen Width :" .. love.graphics.getWidth())
	print("Screen Height :" .. love.graphics.getHeight())
	print("Screen Width * 1/2 :" .. love.graphics.getWidth() / 2)
	print("Screen Height * 1/2 :" .. love.graphics.getHeight() / 2)
	print("Cursor X :" .. love.mouse.getX())
	print("Cursor Y :" .. love.mouse.getY())
	print("Player X :" .. movement.x)
	print("Player Y :" .. movement.y)

	if rotcalc.allowed == 0 then
		rotcalc.x = love.mouse.getX() + camera.x - movement.x
		rotcalc.y = love.mouse.getY() + camera.y - movement.y
		rotcalc.angle = math.atan2(rotcalc.y,rotcalc.x)
	end

	rotcalc.difx = love.mouse.getX() - movement.x
	rotcalc.dify = love.mouse.getY() - movement.y

	movement.x = movement.x + movement.xvel * dt
	movement.y = movement.y + movement.yvel * dt
	movement.xvel = movement.xvel * (1- math.min(dt*movement.friction, 1))
	movement.yvel = movement.yvel * (1- math.min(dt*movement.friction, 1))

	if movement.x > love.graphics.getWidth() / 2 then
		camera.x = movement.x - love.graphics.getWidth() / 2
	else
		camera.x = 0
	end

	if movement.y > love.graphics.getHeight() / 2 then
		camera.y = movement.y - love.graphics.getHeight() / 2 
	else
		camera.y = 0
	end

	if love.keyboard.isDown('w') then
		if rotcalc.difx > -13 and rotcalc.difx < 13 and rotcalc.dify > -13 and rotcalc.dify < 13 then
			print("Bypass Movement!")
		else

			rotcalc.allowed = 0

			movement.x = movement.x + movement.xvel * dt
			movement.y = movement.y + movement.yvel * dt
			movement.xvel = movement.xvel * (1- math.min(dt*movement.friction, 1))
			movement.yvel = movement.yvel * (1- math.min(dt*movement.friction, 1))

			movement.xvel = movement.xvel + movement.speed * dt * math.cos(rotcalc.angle)
  			movement.yvel = movement.yvel + movement.speed * dt * math.sin(rotcalc.angle)
  		end
	end

	if love.keyboard.isDown('s') then
		if rotcalc.difx > -13 and rotcalc.difx < 13 and rotcalc.dify > -13 and rotcalc.dify < 13 then
			print("Bypass Movement!")
		else
			rotcalc.allowed = 0

			movement.x = movement.x + movement.xvel * dt
			movement.y = movement.y + movement.yvel * dt
			movement.xvel = movement.xvel * (1- math.min(dt*movement.friction, 1))
			movement.yvel = movement.yvel * (1- math.min(dt*movement.friction, 1))

			movement.xvel = movement.xvel - movement.speed * dt * math.cos(rotcalc.angle)
  			movement.yvel = movement.yvel - movement.speed * dt * math.sin(rotcalc.angle)
  		end
	end

--	love.mouse.setPosition(getPositionOnCircle(movement.x,movement.y,love.mouse.getX(),love.mouse.getY(),50))
end

function love.draw()

	camera:set()

	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(background, 0, 0)
	love.graphics.draw(char, movement.x, movement.y, rotcalc.angle, 1, 1, 25, 25)

	camera:unset()

end

function camera:set()
	love.graphics.push()
	love.graphics.rotate(-self.rotation)
	love.graphics.scale(1 / self.scaleX, 1 / self.scaleY)
	love.graphics.translate(-self.x, -self.y)
end

function camera:unset()
	love.graphics.pop()
end

function camera:move(dx, dy)
	self.x = self.x + (dx or 0)
	self.y = self.y + (dy or 0)
end

function camera:rotate(dr)
	self.rotation = self.rotation + dr
end

function camera:scale(sx, sy)
	sx = sx or 1
	self.scaleX = self.scaleX * sx
	self.scaleY = self.scaleY * (sy or sx)
end

function camera:setPosition(x, y)
	self.x = x or self.x
	self.y = y or self.y
end

function camera:setScale(sx, sy)
	self.scaleX = sx or self.scaleX
	self.scaleY = sy or self.scaleY
end

--function getPositionOnCircle(px,py,mx,my,r)
--  local dx,dy = mx-px, my-py
--  local dist = math.sqrt(dx^2+dy^2)
--    return px + dx/dist*r, py + dy/dist*r
--end